;#___________________________________________________________________________________________________
;****************************************************************************************************|
; Program Palitra (c) Sergei Steshin (Akyltist)                                                      |
;----------------------------------------------------------------------------------------------------/
;; compiler:     FASM 1.69.31
;; version:      0.10
;; last update:  30/08/2012
;; e-mail:       dr.steshin@gmail.com
;.....................................................................................................
;; All rights reserved.                                                                              |
;;                                                                                                   |
;; Redistribution and use in source and binary forms, with or without modification, are permitted    |
;; provided that the following conditions are met:                                                   |
;;       * Redistributions of source code must retain the above copyright notice, this list of       |
;;         conditions and the following disclaimer.                                                  |
;;       * Redistributions in binary form must reproduce the above copyright notice, this list of    |
;;         conditions and the following disclaimer in the documentation and/or other materials       |
;;         provided with the distribution.                                                           |
;;       * Neither the name of the <organization> nor the names of its contributors may be used to   |
;;         endorse or promote products derived from this software without specific prior written     |
;;         permission.                                                                               |
;;                                                                                                   |
;; THIS SOFTWARE IS PROVIDED BY Marat Zakiyanov ''AS IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES,     |
;; INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A        |
;; PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL <copyright holder> BE LIABLE FOR ANY DIRECT, |
;; INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED    |
;; TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS       |
;; INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT          |
;; LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS  |
;; SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.                                      |
;....................................................................................................|


;#___________________________________________________________________________________________________
;****************************************************************************************************|
;                                                    |
;----------------------------------------------------------------------------------------------------/
  use32
  org	 0x0

  db	 'MENUET01'
  dd	 0x01
  dd	 START
  dd	 I_END
  dd	 0x1000
  dd	 0x1000
  dd	 0x0
  dd	 0x0

include 'macros.inc'

START:
;#___________________________________________________________________________________________________
;****************************************************************************************************|
;    -                                                          |
;----------------------------------------------------------------------------------------------------/
red:
    call draw_window                      ;    
still:
    mcall   10                            ;  10 -  
    cmp     eax,1                         ;   ?
    je      red                           ;   -   red
    cmp     eax,2                         ;   ?
    je      key                           ;   -  key
    cmp     eax,3                         ;   ?
    je      button                        ;   -  button
    jmp     still                         ;    -   
;end_still

key:                                      ;    
    mcall   2                             ;  2 -    ( ah) (    )
    jmp     still                         ;    
;end_key

button:                                   ;   
    mov     eax,17                        ;  17 -    
    int     0x40                          ; 
    cmp     ah, 1                         ;     ID=1 ()
    jz      bexit                         ;  
    cmp     ah, 7                         ;     ID=7 (  )
    jne     bexit                         ;  
    call    mouse_get                     ;     
    jmp     still                         ;     
  bexit:
    mov     eax,-1                        ;  -1 -  
    int     0x40                          ; 
;end_button



;#___________________________________________________________________________________________________
;****************************************************************************************************|
;                                                      |
;----------------------------------------------------------------------------------------------------/
draw_window:
    mov     eax,12                        ;  12: ,    
    mov     ebx,1                         ; 1, 
    int     0x40                          ; 

    mov     eax,48                        ;  48 -   
    mov     ebx,3                         ;  3 -    .
    mov     ecx,sc                        ;     edx ,  
    mov     edx,sizeof.system_colors      ;    (  40 )
    int     0x40                          ; 

    mov     eax,48                        ;  48 -   .
    mov     ebx,4                         ;  4 -  eax =  .
    int     0x40                          ; 
    mov     ecx,eax                       ;   

    xor     eax,eax                       ;  eax (mov eax,0) ( 0)
    mov     ebx,200 shl 16+317            ; [   x]*65536 + [   x]
    add     ecx,200 shl 16+114            ;   + [  y]*65536 + [  y]
    mov     edx,[sc.work]                 ;     
    or      edx,0x34000000                ;      
    mov     edi,title                     ;  
    int     0x40                          ; 

    call    draw_palitra
    call    draw_result

    mov     eax,8                         ;  8 - / 
    mov     ebx,5 shl 16+297              ;     [- x]*65536 + []
    mov     ecx,9 shl 16+72               ;    y [- y]*65536 + []
    mov     edx,0x60000007                ;  ID  - 0xXYnnnnnn
    int     0x40

    mov     eax,12                        ;  12: ,    
    mov     ebx,2                         ; 1, 
    int     0x40                          ; 

    ret                                   ;  


;#___________________________________________________________________________________________________
;****************************************************************************************************|
;                                                       |
;----------------------------------------------------------------------------------------------------/

mouse_get:
    ;.................................................................................................
    ;   
    ;.................................................................................................
    mov     eax,37                        ;  37 -   
    mov     ebx,0                         ;    
    int     0x40                          ; eax = x*65536 + y, (x,y)=  
    mov     ecx,eax                       ;
    shr     ecx,16                        ; ecx = x+1
    movzx   edx,ax                        ; edx = y+1
    dec     ecx                           ; ecx = x
    dec     edx                           ; edx = y
    mov     [mouse_x],ecx                 ; mouse_x = x
    mov     [mouse_y],edx                 ; mouse_y = y

    ;.................................................................................................
    ;   
    ;.................................................................................................
    mov     eax,14                        ;    (eax = [xsize]*65536 + [ysize])
    int     0x40                          ; xsize =    - 1 
    mov     ebx,eax                       ;
    shr     ebx,16                        ; ebx = xsize-1
    ;movzx   edx,ax                       ;; edx = ysize-1 ( )
    inc     ebx                           ; ebx = xsize
    ;inc     edx                          ;; edx = ysize ( )
    imul    ebx,[mouse_y]                 ; ebx = y*xsize
    add     ebx,[mouse_x]                 ; ebx = y*xsize+x

    ;.................................................................................................
    ;      
    ;.................................................................................................
    mov     eax,35                        ;   
    ;mov     ebx,ecx                      ;; ebx = y*xsize+x ( )
    int     0x40                          ;    eax
    cmp     eax,[sc.work]                 ;    
    je      mouse_exit                    ;    -    
    cmp     eax,0x222222                  ;    
    je      mouse_exit                    ;    -    
    mov     [color],eax                   ;    
    call    draw_result                   ;  
    mouse_exit:
    ret                                   ;  
;end_mouse_get----------------------------------------------------------------------------------------

draw_palitra:
    ;.................................................................................................
    ;    
    ;.................................................................................................
    mov     eax,13                        ;  13 -  
    mov     edx,0x222222                  ; 
    mov     ebx,5 shl 16+73               ;    x [- x]*65536 + []
    mov     ecx,9 shl 16+73               ;    y [- y]*65536 + []
    mov     edi,4                         ;   
    for_fon_loop:
      int     0x40                        ; 
      add     ebx,75 shl 16               ;     y
      dec     edi                         ;   
      cmp     edi,0                       ;   
    jnz     for_fon_loop                  ;       

    ;.................................................................................................
    ;    
    ;.................................................................................................
    mov     eax,13                        ;  13 -  
    mov     edx,0x0FFFFFFF                ; 
    mov     edi,4                         ;    (#4,8)
    mov     ebx,-6 shl 16+8               ;    x [- x]*65536 + []
    for_abz:
      push    edi                         ;      
      add     ebx,3 shl 16                ;     x
      mov     edi,8                       ;     
      for_stolbik:
        push    edi                       ;      
        mov     edi,8                     ;     
        mov     ecx,  1 shl 16+8          ;    y [- y]*65536 + []        
        add     ebx,9 shl 16              ;     x
        for_loop:
          add     ecx,9 shl 16            ;     y
          int     0x40                    ; 
          sub     edx,32 shl 16
          dec     edi                     ;   
          cmp     edi,0                   ;   
          jnz     for_loop                ;       
      sub     edx,32 shl 8
      pop     edi                         ;    
      dec     edi                         ;  
      cmp     edi,0                       ;   
      jnz     for_stolbik                 ;       
    sub     edx,64                        ; (#64,32)
    pop     edi                           ;    
    dec     edi                           ;  
    cmp     edi,0                         ;   
    jnz     for_abz                       ;       
    ret                                   ;  
;end_draw_palitra-------------------------------------------------------------------------------------

draw_result:
    ;.................................................................................................
    ;     hex,bin (rgba-)
    ;.................................................................................................
    mov     eax,13                        ;  13 -  
    mov     edx,0x222222                  ; -
    mov     ebx,5 shl 16+15               ;    x [- x]*65536 + []
    mov     ecx,90 shl 16+15              ;    y [- y]*65536 + []
    int     0x40                          ;  (  )
    mov     ebx,25 shl 16+73              ;    x [- x]*65536 + []
    mov     ecx,90 shl 16+15              ;    y [- y]*65536 + []
    int     0x40                          ;  (  )
    mov     ebx,100 shl 16+203            ;    x [- x]*65536 + []
    mov     ecx,90 shl 16+15              ;    y [- y]*65536 + []
    int     0x40                          ;  (  )

    mov     edx,[color]                   ; -
    mov     ebx,6 shl 16+13               ;    x [- x]*65536 + []
    mov     ecx,91 shl 16+13              ;    y [- y]*65536 + []
    int     0x40                          ;  (  )

    mov     edx,[sc.work]                 ; -
    mov     ebx,26 shl 16+71              ;    x [- x]*65536 + []
    mov     ecx,91 shl 16+13              ;    y [- y]*65536 + []
    int     0x40                          ;  (  )
    mov     ebx,101 shl 16+201            ;    x [- x]*65536 + []
    mov     ecx,91 shl 16+13              ;    y [- y]*65536 + []
    int     0x40                          ;  (  )

    mov     eax,47                        ;  47 -    
    mov     ecx,[color]                   ;  ( bl=0)   ( bl=1)
    mov     esi,0x0                       ; 0xX0RRGGBB
    mov     ebx,256+8 shl 16              ;      (HEX)
    mov     edx,38 shl 16+94              ; [   x]*65536 + [   y]
    int     0x40                          ;  -     (HEX)
    mov     ebx,256*2+32 shl 16           ;      (BIN)
    mov     edx,106 shl 16+94             ; [   x]*65536 + [   y]
    int     0x40                          ;  -     (BIN)
    ret                                   ;  
;end_draw_result


;#___________________________________________________________________________________________________
;****************************************************************************************************|
;                                                                             |
;----------------------------------------------------------------------------------------------------/

    color       dd 00ffff00h              ;    
    mouse_x     dd 0                      ;     
    mouse_y     dd 0                      ;     
    sc          system_colors             ;     
    title       db 'Palitra',0            ;   

I_END:


